Gaps
curl --request POST \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"budgetVersion": "live",
"scopeKey": "project:total",
"origin": "pricing",
"filters": {
"categoryIds": [
"<string>"
],
"supplierCompanyIds": [
"<string>"
],
"areaIds": [
"<string>"
]
},
"cursor": "<string>",
"limit": 20,
"expectedRevision": "<string>"
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query"
payload = {
"budgetVersion": "live",
"scopeKey": "project:total",
"origin": "pricing",
"filters": {
"categoryIds": ["<string>"],
"supplierCompanyIds": ["<string>"],
"areaIds": ["<string>"]
},
"cursor": "<string>",
"limit": 20,
"expectedRevision": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
budgetVersion: 'live',
scopeKey: 'project:total',
origin: 'pricing',
filters: {
categoryIds: ['<string>'],
supplierCompanyIds: ['<string>'],
areaIds: ['<string>']
},
cursor: '<string>',
limit: 20,
expectedRevision: '<string>'
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'budgetVersion' => 'live',
'scopeKey' => 'project:total',
'origin' => 'pricing',
'filters' => [
'categoryIds' => [
'<string>'
],
'supplierCompanyIds' => [
'<string>'
],
'areaIds' => [
'<string>'
]
],
'cursor' => '<string>',
'limit' => 20,
'expectedRevision' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query"
payload := strings.NewReader("{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"budgetVersion": {
"kind": "live",
"id": "<string>",
"number": 123,
"releasedAt": "<string>"
},
"scope": {
"comparisons": {},
"key": "<string>",
"label": "<string>",
"coverage": {
"lineCount": 123,
"purchasingShortfallCount": 123,
"installedShortfallCount": 123,
"requiredStockShortfallCount": 123,
"budgetGapCount": 123,
"costGapCount": 123,
"clientGapCount": 123,
"incompleteInputCount": 123
},
"revision": "<string>",
"margin": {
"specified": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
},
"purchase": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
}
},
"effectiveSoftCostEstimate": "<string>"
},
"comparison": "planning_itemized",
"side": "cost",
"summary": {
"baseline": "<string>",
"compared": "<string>",
"variance": {
"amount": "<string>",
"pct": "<string>"
},
"state": "incomplete",
"adverse": true
},
"items": [
{
"decomposition": {
"state": "incomplete",
"baseline": "<string>",
"compared": "<string>",
"steps": [
{
"kind": "override",
"amount": "<string>"
}
]
},
"coverage": {
"lineCount": 123,
"purchasingShortfallCount": 123,
"installedShortfallCount": 123,
"requiredStockShortfallCount": 123,
"budgetGapCount": 123,
"costGapCount": 123,
"clientGapCount": 123,
"incompleteInputCount": 123
},
"inputs": {
"unitsPerPackage": "<string>",
"budgetPrice": "<string>",
"budgetQuantity": "<string>",
"unitCost": "<string>",
"unitClient": "<string>"
},
"key": "<string>",
"slotId": "<string>",
"projectItemId": "<string>",
"label": "<string>",
"refNumber": "<string>",
"categoryId": "<string>",
"supplierName": "<string>",
"baseline": "<string>",
"compared": "<string>",
"contribution": "<string>",
"contributionPct": "<string>",
"state": "incomplete",
"adverse": true,
"quantities": {
"specified": "<string>",
"specifiedOrder": "<string>",
"purchase": "<string>",
"purchasedUnits": "<string>",
"shortfall": "<string>",
"requiredUnits": "<string>",
"requiredStockShortfall": "<string>",
"additionalOrderQuantity": "<string>",
"parLevel": "<string>",
"applyParToPurchaseQuantity": true,
"extraQuantity": "<string>",
"purchasingUnit": "packages"
},
"softCosts": [
{
"id": "<string>",
"label": "<string>",
"source": "override",
"mode": "percentage",
"rate": "<string>",
"defaultRate": "<string>",
"fixedAmount": "<string>",
"defaultEstimate": "<string>",
"effectiveEstimate": "<string>",
"budgetBasis": "<string>",
"specifiedBasis": "<string>",
"purchaseBasis": "<string>",
"specified": "<string>",
"purchase": "<string>"
}
],
"margin": {
"specified": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
},
"purchase": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
}
}
}
],
"matchedCount": 123,
"totalCount": 123,
"nextCursor": "<string>",
"hasMore": true,
"computedAt": "<string>",
"freshness": "live",
"revision": "<string>",
"changed": true,
"reconciliation": {
"allowance": "<string>",
"contributionTotal": "<string>",
"grossAdverse": "<string>",
"favorableOffsets": "<string>",
"matchingContributionTotal": "<string>",
"pageContributionTotal": "<string>",
"otherContributionTotal": "<string>"
}
}Budget Analysis
Gaps
POST
/
v1
/
workspaces
/
{workspaceId}
/
projects
/
{projectId}
/
budget-analysis
/
gaps
/
query
Gaps
curl --request POST \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"budgetVersion": "live",
"scopeKey": "project:total",
"origin": "pricing",
"filters": {
"categoryIds": [
"<string>"
],
"supplierCompanyIds": [
"<string>"
],
"areaIds": [
"<string>"
]
},
"cursor": "<string>",
"limit": 20,
"expectedRevision": "<string>"
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query"
payload = {
"budgetVersion": "live",
"scopeKey": "project:total",
"origin": "pricing",
"filters": {
"categoryIds": ["<string>"],
"supplierCompanyIds": ["<string>"],
"areaIds": ["<string>"]
},
"cursor": "<string>",
"limit": 20,
"expectedRevision": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
budgetVersion: 'live',
scopeKey: 'project:total',
origin: 'pricing',
filters: {
categoryIds: ['<string>'],
supplierCompanyIds: ['<string>'],
areaIds: ['<string>']
},
cursor: '<string>',
limit: 20,
expectedRevision: '<string>'
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'budgetVersion' => 'live',
'scopeKey' => 'project:total',
'origin' => 'pricing',
'filters' => [
'categoryIds' => [
'<string>'
],
'supplierCompanyIds' => [
'<string>'
],
'areaIds' => [
'<string>'
]
],
'cursor' => '<string>',
'limit' => 20,
'expectedRevision' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query"
payload := strings.NewReader("{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget-analysis/gaps/query")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"budgetVersion\": \"live\",\n \"scopeKey\": \"project:total\",\n \"origin\": \"pricing\",\n \"filters\": {\n \"categoryIds\": [\n \"<string>\"\n ],\n \"supplierCompanyIds\": [\n \"<string>\"\n ],\n \"areaIds\": [\n \"<string>\"\n ]\n },\n \"cursor\": \"<string>\",\n \"limit\": 20,\n \"expectedRevision\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"budgetVersion": {
"kind": "live",
"id": "<string>",
"number": 123,
"releasedAt": "<string>"
},
"scope": {
"comparisons": {},
"key": "<string>",
"label": "<string>",
"coverage": {
"lineCount": 123,
"purchasingShortfallCount": 123,
"installedShortfallCount": 123,
"requiredStockShortfallCount": 123,
"budgetGapCount": 123,
"costGapCount": 123,
"clientGapCount": 123,
"incompleteInputCount": 123
},
"revision": "<string>",
"margin": {
"specified": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
},
"purchase": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
}
},
"effectiveSoftCostEstimate": "<string>"
},
"comparison": "planning_itemized",
"side": "cost",
"summary": {
"baseline": "<string>",
"compared": "<string>",
"variance": {
"amount": "<string>",
"pct": "<string>"
},
"state": "incomplete",
"adverse": true
},
"items": [
{
"decomposition": {
"state": "incomplete",
"baseline": "<string>",
"compared": "<string>",
"steps": [
{
"kind": "override",
"amount": "<string>"
}
]
},
"coverage": {
"lineCount": 123,
"purchasingShortfallCount": 123,
"installedShortfallCount": 123,
"requiredStockShortfallCount": 123,
"budgetGapCount": 123,
"costGapCount": 123,
"clientGapCount": 123,
"incompleteInputCount": 123
},
"inputs": {
"unitsPerPackage": "<string>",
"budgetPrice": "<string>",
"budgetQuantity": "<string>",
"unitCost": "<string>",
"unitClient": "<string>"
},
"key": "<string>",
"slotId": "<string>",
"projectItemId": "<string>",
"label": "<string>",
"refNumber": "<string>",
"categoryId": "<string>",
"supplierName": "<string>",
"baseline": "<string>",
"compared": "<string>",
"contribution": "<string>",
"contributionPct": "<string>",
"state": "incomplete",
"adverse": true,
"quantities": {
"specified": "<string>",
"specifiedOrder": "<string>",
"purchase": "<string>",
"purchasedUnits": "<string>",
"shortfall": "<string>",
"requiredUnits": "<string>",
"requiredStockShortfall": "<string>",
"additionalOrderQuantity": "<string>",
"parLevel": "<string>",
"applyParToPurchaseQuantity": true,
"extraQuantity": "<string>",
"purchasingUnit": "packages"
},
"softCosts": [
{
"id": "<string>",
"label": "<string>",
"source": "override",
"mode": "percentage",
"rate": "<string>",
"defaultRate": "<string>",
"fixedAmount": "<string>",
"defaultEstimate": "<string>",
"effectiveEstimate": "<string>",
"budgetBasis": "<string>",
"specifiedBasis": "<string>",
"purchaseBasis": "<string>",
"specified": "<string>",
"purchase": "<string>"
}
],
"margin": {
"specified": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
},
"purchase": {
"client": "<string>",
"cost": "<string>",
"profit": "<string>",
"marginPct": "<string>",
"targetPct": "<string>",
"belowTarget": true,
"state": "incomplete"
}
}
}
],
"matchedCount": 123,
"totalCount": 123,
"nextCursor": "<string>",
"hasMore": true,
"computedAt": "<string>",
"freshness": "live",
"revision": "<string>",
"changed": true,
"reconciliation": {
"allowance": "<string>",
"contributionTotal": "<string>",
"grossAdverse": "<string>",
"favorableOffsets": "<string>",
"matchingContributionTotal": "<string>",
"pageContributionTotal": "<string>",
"otherContributionTotal": "<string>"
}
}Authorizations
Path Parameters
Body
application/json
scopeKey
Option 1 · enum<string>Option 2 · enum<string>Option 3 · enum<string>Option 4 · stringOption 5 · enum<string>Option 6 · stringOption 7 · enum<string>Option 8 · stringOption 9 · enum<string>Option 10 · stringOption 11 · stringOption 12 · string
required
Available options:
project:total Response
200 - application/json
⌘I